package reti;

import java.util.*;
public class ISCache
{
	public ISCache(int dimensione)
	{
		cache = new ISCacheItem[dimensione];
		head = -1;
		num_element = 0;
	}
	
	public synchronized QueryResult search(ColorHistogram color, int numero)
	{
		int index = exist(color,numero);
		if (index!=-1) return cache[index].getQueryResult();
		else return (QueryResult) null;
	}
	
	public synchronized void insert(ISCacheItem isci)
	{
		head = (head+1) % cache.length;
		cache[head] = isci;
		if (num_element<cache.length) num_element++;
	}
	
	private int exist(ColorHistogram color, int numero)
	{
		boolean trovato = false;
		int i = 0;
		while ( (!trovato) && (i<num_element) )
		{
			ISCacheItem isci = cache[i];
			if ( (isci.getColorHistogram().equals(color)) && (isci.getK()>=numero) ) trovato = true;
			else i++;
		}
		if (trovato) return i;
		else return -1;
	}
	
	private ISCacheItem[] cache;
	private int head;
	private int num_element;
}

class ISCacheItem
{
	public ISCacheItem(ColorHistogram c, int k, QueryResult result)
	{
		ch = c;
		number = k;
		qr = result;
	}
	
	public ColorHistogram getColorHistogram()
	{ return ch; }
	
	public int getK()
	{ return number; }
	
	public QueryResult getQueryResult()
	{ return qr; }
	
	private ColorHistogram ch;
	private int number;
	private QueryResult qr;
}