package reti;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

/** Finestra di dialogo per l'immmissione dei parametri di comunicazione dell'Image Server */
public class ISFinestraImpostazioni extends JDialog implements ActionListener
{
	public ISFinestraImpostazioni ()
	{
		super((JFrame)null,"IMPOSTAZIONI",true);
		Border etched = BorderFactory.createEtchedBorder();
		Border titled1 = BorderFactory.createTitledBorder(etched,"MASTER 1");
		Border titled2 = BorderFactory.createTitledBorder(etched,"MASTER 2");
		Border titled3 = BorderFactory.createTitledBorder(etched,"IMAGE SERVER");
		master1 = new JTextField("",15);
		master2 = new JTextField("",15);
		port1 = new JTextField("",7);
		port2 = new JTextField("",7);
		myport = new JTextField("",7);
		JPanel p1 = new JPanel();
		p1.setBorder(titled1);
		p1.add(new JLabel("HOST:"));
		p1.add(master1);
		p1.add(new JLabel("   PORT"));
		p1.add(port1);
		JPanel p2 = new JPanel();
		p2.setBorder(titled2);
		p2.add(new JLabel("HOST:"));
		p2.add(master2);
		p2.add(new JLabel("   PORT"));
		p2.add(port2);
		JPanel p3 = new JPanel();
		p3.setBorder(titled3);
		p3.add(new JLabel("   PORT"));
		p3.add(myport);
		JPanel p4 = new JPanel();
		okButton = new JButton("OK");
		okButton.addActionListener(this);
		p4.add(okButton);
		GridLayout layout = new GridLayout(3,1);
		JPanel p = new JPanel();
		p.setLayout(layout);
		p.add(p1);
		p.add(p2);
		p.add(p3);
		getContentPane().add(p,"Center");
		getContentPane().add(p4,"South");
		setSize(400,250);
	}
	
	public void actionPerformed(ActionEvent e)
	{
		Object source = e.getSource();
		if (source==okButton)
		{
			ok = true;
			setVisible(false);
		}
	}
	
	public void showDialog(ISConnectionInfo transfer)
	{
		master1.setText(transfer.HostMaster1);
		master2.setText(transfer.HostMaster2);
		port1.setText(String.valueOf(transfer.PortMaster1));
		port2.setText(String.valueOf(transfer.PortMaster2));
		myport.setText(String.valueOf(transfer.PortImageServer));
		ok = false;
		show();
		if (ok)
		{
			transfer.HostMaster1 = master1.getText();
			transfer.HostMaster2 = master2.getText();
			transfer.PortMaster1 = Integer.parseInt(port1.getText());
			transfer.PortMaster2 = Integer.parseInt(port2.getText());
			transfer.PortImageServer = Integer.parseInt(myport.getText());
		}
	}
	
	private boolean ok;
	private JButton okButton;
	private JTextField master1;
	private JTextField master2;
	private JTextField port1;
	private JTextField port2;
	private JTextField myport;
}