package reti;

import java.io.*;
import java.util.*;

/* collezione di features */
public class ImageFeatureCollection
{
	public ImageFeatureCollection(String filename)
	{
		File f = new File(filename);
		if ( f.exists() ) load(f);
		else { System.out.println("File Dati NON Trovato !!"); System.exit(1); }
	}

/* restituisce la dimensione della collezione */	
	public int getSize()
	{ return features.size(); }
	
/* restituisce gli ID delle K feature pi simili a quella data */
	public QueryResult getSimilar(ColorHistogram qch, int k)
	{
		QueryResult qr = new QueryResult(k);
		for ( int i=0; i<features.size(); i++ )
		{
			ImageFeature ifaux = (ImageFeature) features.get(i);
			float dist = qch.getDistance(ifaux.getColorHistogram());
			if ( dist < qr.getMax() ) qr.insert(new QueryResultEntry(ifaux.getName(),dist));
		}
		return qr;
	}
	
/* carica la collezione */
	private void load(File file)
	{
		try {
			ObjectInputStream in = new ObjectInputStream(new FileInputStream(file));
			int length = in.readInt();
			features = new ArrayList(length);
			for ( int i=0; i<length; i++ ) features.add((ImageFeature) in.readObject());
			in.close();
		}
		catch (Exception e) 
		{ 	System.out.println("ERRORE DURANTE IL CARICAMENTO DELLA COLLEZIONE DI IMMAGINI");
			System.exit(1);
		}
	}
	
	private ArrayList features=null;
}