import reti.*;
import java.net.*;
import java.io.*;

public class ImageServer 
{
	public static void main(String args[])
	{
		ImageServer is = new ImageServer(args[0]);
		
		/* registrazione presso un master server */
		if ( !is.bind() ) System.exit(1);		
		
		System.out.println(" exit per terminare");
		/* attesa del comando di terminazione */
		BufferedReader console = new BufferedReader(new InputStreamReader(System.in));
		try {
			do {} while (console.readLine()=="exit");
		}
		catch (IOException e) {}
		is.termina();
	}
	
	public ImageServer(String filedati)
	{
		ifc = new ImageFeatureCollection(filedati);
		ISConnectionInfo info =new ISConnectionInfo();
		impostazioni=new ISFinestraImpostazioni();
		impostazioni.showDialog(info);
		MyPort=info.PortImageServer;
		try { IPMaster1=InetAddress.getByName(info.HostMaster1); }
		catch (UnknownHostException e) {IPMaster1=null;}
		try { IPMaster2=InetAddress.getByName(info.HostMaster2); }
		catch (UnknownHostException e) {IPMaster2=null;}
		PortMaster1=info.PortMaster1;
		PortMaster2=info.PortMaster2;
		cache = new ISCache(30);
		gestore = new ISGestoreRichieste(MyPort,ifc,cache);
		gestore.start();
	}
	
	/* esegue l'operazione di BIND */
	public boolean bind()
	{
		if ( !esegui("BIND",IPMaster1,PortMaster1,1) ) 		/* BIND su MASTER 1 */
			if ( !esegui("BIND",IPMaster2,PortMaster2,2) )  /* BIND su MASTER 2 */
				return false;
		return true;
	}
	
	/* esegue l'operazione di UNBIND */
	public boolean unbind()
	{
		if ( !esegui("UNBIND",IPMaster1,PortMaster1,1) )		/* UNBIND su MASTER 1 */
			if ( !esegui("UNBIND",IPMaster2,PortMaster2,2) ) 	/* UNBIND su MASTER 2 */
				return false;
		return true;
	}
		
	private boolean esegui(String messaggio, InetAddress ip, int port, int master)
	{
		System.out.println("Tento di collegarmi al MASTER "+master+" ...");
		try {
			Socket socket=new Socket(ip,port);
			socket.setSoTimeout(TIMEOUT_LETTURA);
			ObjectOutputStream out=new ObjectOutputStream(socket.getOutputStream());
			ObjectInputStream in=new ObjectInputStream(socket.getInputStream());
			if (messaggio.equals("BIND")) out.writeInt(Command.BIND);
			else if (messaggio.equals("UNBIND")) out.writeInt(Command.UNBIND);
			out.writeInt(MyPort);
			out.flush();
			int esito=in.readInt();
			out.close();
			in.close();
			socket.close();	
			if (esito!=Command.OK)
				{
					System.out.println(messaggio+" su MASTER "+master+" non riuscito !!"); 
					return false;
				}
			else 
				{ 
					System.out.println(messaggio+" su MASTER "+master+" effettuato !!"); 
					return true;
				}
			}
			catch (InterruptedIOException e) 
			{
				System.out.println("Il MASTER "+master+" non risponde !!"); 
				return false;
			}
			catch(Exception e)
			{
				System.out.println(messaggio+" non riuscito: "+e.getClass().getName()+"   "+
					e.getMessage()); 
				return false;
			}
	}
	
	private void termina()
	{
		unbind();
		System.exit(0);
	}
		
	private ISFinestraImpostazioni impostazioni;
	private final int MyPort;
	private InetAddress IPMaster1;
	private InetAddress IPMaster2;
	private int PortMaster1;
	private int PortMaster2;
	private ImageFeatureCollection ifc;
	private ISCache cache;
	private ISGestoreRichieste gestore;
	private static final int TIMEOUT_LETTURA=2000;
}