package reti;

import java.net.*;
import java.io.*;
import java.util.*;


/** Gestisce la comunicazione con il Master Server secondario*/ 
public class MSCoordinazioneMaster
{
	public MSCoordinazioneMaster(String hostMaster2, int portMaster2)
	{
		try { host = InetAddress.getByName(hostMaster2); }
		catch (UnknownHostException e) { host = null; }
		porta = portMaster2;
	}
	
/** richiede l'aggiornamento della lista di Image Server */
	public Vector updateLista()
	{
		try {
			System.out.println("aggiornamento elenco IMAGE SERVER da master 2 in corso ...");
			Socket socket = new Socket(host,porta);
			ObjectOutputStream out = new ObjectOutputStream(socket.getOutputStream());
			ObjectInputStream in = new ObjectInputStream(socket.getInputStream());
			socket.setSoTimeout(TIMEOUT_UPDATE);
			out.writeInt(Command.UPDATE);
			out.flush();
			Vector lista = (Vector) in.readObject();
			out.close();
			in.close();
			socket.close();
			int dim = lista.size();
			for (int i=0; i<dim;i++) System.out.println( (ISListEntry) lista.get(i) );
			System.out.println("aggiornamento completato !!");
			return lista;
		}
		catch (Exception e) 
		{
			System.out.println("master 2 down."+e.getMessage()); 
			Vector lista_vuota = new Vector(5);
			return lista_vuota;
		}
	}

/** consente di inviare un messaggio al master secondario */	
	public void notificaMessaggio(int type, InetAddress ip, int port)
	{
		try {
			Socket socket = new Socket(host,porta);
			socket.setSoTimeout(TIMEOUT_MESSAGE);
			ObjectOutputStream out2 = new ObjectOutputStream(socket.getOutputStream());
			ObjectInputStream in2 = new ObjectInputStream(socket.getInputStream());
			out2.writeInt(type);
			out2.writeObject(ip);
			out2.writeInt(port);
			out2.flush();
			in2.readInt();
			out2.close();
			in2.close();
			socket.close();
		}
		catch (Exception e)
		{ System.out.println("Il master 2 non risponde."); }
	}
	
	private InetAddress host;	/* INDIRIZZO IP DEL MASTER 2*/
	private int porta;			/* NUMERO DI PORTA TCP DEL MASTER 2 */
	private static final int TIMEOUT_UPDATE = 15000;
	private static final int TIMEOUT_MESSAGE = 10000;
}