package reti;

import java.util.*;

public class MSQueryResult
{
	public MSQueryResult(int maxsize)
	{
		array = new MSQueryResultItem[maxsize];
		index=0;
		MSQueryResultItem item = new MSQueryResultItem("","",1);
		for (int i=0; i<maxsize; i++) array[i]=item;
	}
	
	public synchronized void add(MSQueryResultItem item)
	{
		array[index] = item;
		index++;
	}
	
	public int getSize()
	{ return index; }
	
	public MSQueryResultItem get(int i)
	{
		return array[i];
	}
	
	public void sort()
	{
		Arrays.sort(array);
	}

	private MSQueryResultItem[] array;
	private int index;
}

class MSQueryResultItem implements Comparable
{
	public MSQueryResultItem(String nomehost, String nomeimg,float value)
	{
		host = nomehost;
		name = nomeimg;
		distance = value;
	}

	public String getHost()
	{
		return host;
	}
	
	public String getName()
	{
		return name;
	}
	
	public float getDistance()
	{
		return distance;
	}
	
	public int compareTo(Object o)
	{
		MSQueryResultItem other=(MSQueryResultItem) o;
		if (distance<other.distance) return -1;
		if (distance==other.distance) return 0;
		return 1;
	}

	private String host;
	private String name;
	private float distance;
}