package reti;

import java.util.*;
import java.text.*;

public class QueryResult
{
	public QueryResult(int k)
	{
		qr=new QueryResultEntry[k];
		for (int i=0;i<k;i++) qr[i]=new QueryResultEntry();
		max=1;
		index=0;
	}
	
	public float getMax()
	{ return max; }

	public void insert(QueryResultEntry qre)
	{
		qr[index]=qre;
		max=qr[0].getDistance();
		index=0;
		for (int i=1;i<qr.length;i++)
			if (max<qr[i].getDistance())
			{ 
				max=qr[i].getDistance();
				index=i;
			}
	}

	public QueryResultEntry get(int index)
	{
		if (index>=qr.length) return null;
		return qr[index];
	}
	
	public void sort()
	{
		Arrays.sort(qr);
		max=qr[qr.length-1].getDistance();
		index=qr.length-1;
	}
	
	public void print()
	{
		for (int i=0;i<qr.length;i++) qr[i].print();
	}
	
	private QueryResultEntry[] qr;
	private float max;
	private int index;
}

class QueryResultEntry implements Comparable
{
	public QueryResultEntry()
	{
		name="";
		distance=1;
	}
	
	public QueryResultEntry(String nome,float dist)
	{
		name=nome;
		distance=dist;
	}
	
	public float getDistance()
	{ return distance; }
	
	public String getName()
	{
		return name;
	}

	public int compareTo(Object o)
	{
		QueryResultEntry other=(QueryResultEntry) o;
		if (distance<other.distance) return -1;
		if (distance==other.distance) return 0;
		return 1;
	}

	public void print()
	{
		NumberFormat nf=NumberFormat.getNumberInstance();
		nf.setMaximumFractionDigits(3);
		nf.setMinimumFractionDigits(3);
		System.out.print(name);
		for (int i=name.length();i<40;i++) System.out.print(" ");
		System.out.println(nf.format(distance));
	}
	
	private String name;
	private float distance;
}